package net.swordie.ms.handlers.header;

import java.util.Arrays;
import java.util.List;

/**
 * Created on 2/18/2017.
 */
public enum OutHeader {
    // Redirector Headers
    UNKNOWN(0x7775),
    CHECK_CLIENT(0x7776),
    SET_OPS(0x7777),
    REQUEST_WZ(0x7778),
    OPEN_WEBSITE(0x7779),

    // GMS Headers
    CHAT_LOGIN_RESULT(-1),
    CHAT_LOGOUT_RESULT(-1),
    CHAT_ALIVE_REQ(-1),
    CHAT_ENTER_GUILD_CHAT_ROOM_RESULT(-1),
    CHAT_GUILD_CHAT_MESSAGE(-1),
    CHAT_FRIEND_CHAT_MESSAGE(-1),
    CHAT_BLOCK_GUILD_FRIEND_CHAT(-1),
    CHECK_PASSWORD_RESULT(0),
    WORLD_INFORMATION(1),
    LATEST_CONNECTED_WORLD(2),
    RECOMMENDED_WORLD_MESSAGE(3),
    SET_CLIENT_KEY(4),
    SET_PHYSICAL_WORLD_ID(5),
    SELECT_WORLD_BUTTON(6),
    SELECT_WORLD_RESULT(7),
    SELECT_CHARACTER_RESULT(8),
    ACCOUNT_INFO_RESULT(9),
    CREATE_MAPLE_ACCOUNT_RESULT(10),
    CHECK_DUPLICATED_ID_RESULT(11),
    CREATE_NEW_CHARACTER_RESULT(12),
    DELETE_CHARACTER_RESULT(13),
    RESERVED_DELETE_CHARACTER_RESULT(14),
    RESERVED_DELETE_CHARACTER_CANCEL_RESULT(15),
    SET_CHARACTER_ID(16),
    MIGRATE_COMMAND(17),
    ALIVE_REQ(18),
    PING_CHECK_RESULT(19),
    UNK20(20),
    AUTHEN_CODE_CHANGED(21),
    AUTHEN_MESSAGE(22),
    SECURITY_PACKET(23),
    UNK24(24),
    PRIVATE_SERVER_PACKET(25),
    UNK26(26),
    UNK27(27),
    UNK28(28),
    UNK29(29),
    UNK30(30),
    CHANGE_SPW_RESULT(31),
    CHECK_SPW_EXIST_RESULT(32),
    CHECK_WEB_LOGIN_EMAIL_ID(33),
    DELETE_CHARACTER_OTP_REQUEST(34),
    CHECK_CRC_RESULT(35),
    NOTIFY_CENTER_AND_GAME_ARE_CONNECTED(36),
    CHECK_ALIVE_ACK(37),
    SET_AUTO_SELECTED_WORLD(38),
    WORLD_INFO_FOR_SHINING_RESULT(39),
    CLIENT_START(40),
    INIT_OPCODE_ENCRYPTION(41),
    SET_JOB_RESULT(61),
    UNK64(64),
    UNK65(65),
    LOGIN_TIME(67),
    UNK68(68),
    UNK69(69),
    ALBA_RESULT(-1),
    SERVER_STATUS(-1),
    AUTH_SERVER(-1),


    SET_BACK_EFFECT(71),
    SET_MAP_TAGGED_OBJECT_VISISBLE(72),
    SET_MAP_tAGGED_OBJECT_SMOOTH_VISIBLE(73),
    SET_MAP_TAGGED_OBJECT_ANIMATION(74),
    SET_MAP_OBJECT_ANIMATION(75),
    SET_MAP_OBJECT_VISIBLE(76),
    SET_MAP_OBJECT_MOVE(77),
    SET_MAP_OBJECT_CREATE_LAYER(78),
    SET_SPINE_BACK_EFFECT(79),
    SET_SPINE_OBJECT_EFFECT(80),
    CREATE_SPINE_RECT_EVENT(81),
    REMOVE_SPINE_RECT_EVENT(82),
    SPINE_RE_ADD_BACK_EVENT(83),
    SPINE_RE_ADD_OBJECT_EVENT(84),
    CREATE_CAMERA_CTRL_ZONE(85),
    REMOVE_CAMERA_CTRL_ZONE(86),
    UNK86(87),
    UNK87(88),
    UNK88(88),
    RELOAD_BACK(90),

    // CWvsContext::OnPacket
    INVENTORY_OPERATION(91), // v205
    INVENTORY_GROW(92),// v205
    STAT_CHANGED(93),// v205
    TEMPORARY_STAT_SET(94),// v205
    TEMPORARY_STAT_RESET(95),// v205
    UNK205_96(96), // unk
    FORCED_STAT_SET(97),// v205
    FORCED_STAT_RESET(98),// v205
    CHANGE_SKILL_RECORD_RESULT(99),// v205
    CHANGE_STEAL_MEMORY_RESULT(100),// v205
    USER_DAMAGE_ON_FALLING_CHECK(101),// v205
    PERSONAL_SHOP_BUY_CHECK(102),// v205
    MOB_DROP_MESO_PICKUP(103),// v205
    BREAK_TIME_FIELD_ENTER(104),// v205
    RUNE_ACT_SUCCESS(105),// v205
    RESULT_STEAL_SKILL_LIST(106),// v205
    SKILL_USE_RESULT(107),// v205
    EXCL_REQUEST(108), // v205
    GIVE_POPULARITY_RESULT(109), // v205
    MESSAGE(110), // v205
    MEMO_RESULT(111),// v205
    MAP_TRANSFER_RESULT(112),// v205
    UNK111(113),// new v203.2
    ANTI_MACRO_RESULT(-1),
    ANTI_MACRO_BOMB_RESULT(115),// v205
    UNK114(114),
    UNK115(115),
    UNK116(116),// new v203.2
    UNK117(117),
    UNK118(118),
    CLAIM_RESULT(119),// v205
    SET_CLAIM_SVR_AVAILABLE_TIME(120),
    CLAIM_SVR_STATUS_CHANGED(121),
    UNK122(122),// new v203.2
    STAR_PLANET_USER_COUNT(123),
    SET_TAMING_MOB_INFO(124),
    QUEST_CLEAR(128), // v205
    ENTRUSTED_SHOP_CHECK_RESULT(129), // v205
    SKILL_LEARN_ITEM_RESULT(130), // v205
    SKILL_RESET_ITEM_RESULT(131), // v205
    ABILITY_RESET_ITEM_RESULT(132), // v205
    EXP_CONSUME_ITEM_RESULT(133), // v205
    EXP_ITEM_GET_RESULT(134), // v205
    CHAR_SLOT_INC_RESULT(135), // v205
    GATHER_ITEM_RESULT(136), // v205
    SORT_ITEM_RESULT(137), // v205
    UNK135(138),// v205
    UNK136(139),// v205
    //
    CHARACTER_INFO(140),// v205
    PARTY_RESULT(141),// v205
    PARTY_MEMBER_CANDIDATE_RESULT(142),// v205
    URUS_PARTY_MEMBER_CANDIDATE_RESULT(143),// v205
    PARTY_CANDIDATE_RESULT(144),// v205
    URUS_PARTY_RESULT(145),// v205
    INTRUSION_FRIEND_CANDIDATE_RESULT(146),// v205
    INTRUSION_LOBBY_CANDIDATE_RESULT(147),// v205
    //
    EXPEDITION_RESULT(149),// v205
    FRIEND_RESULT(150),// v205
    GUILD_REQUEST(152),// v205
    GUILD_RESULT(153),// v205
    ALLIANCE_RESULT(154),// v205
    TOWN_PORTAL(155),// v205
    BROADCAST_MSG(156),// v205
    INCUBATOR_RESULT(157),// v205
    INCUBATOR_HOT_ITEM_RESULT(158),// v205
    SHOP_SCANNER_RESULT(159),// v205
    SHOP_LINK_RESULT(160),// v205
    MARRIAGE_REQUEST(161),// v205
    MARRIAGE_RESULT(162),// v205
    WEDDING_GIFT_RESULT(163),// v205
    //idk
    NOTIFY_MARRIED_PARTNER_MAP_TRANSFER(165),// v205
    CASHPET_FOOD_RESULT(166),// v205
    CASHPET_PICK_UP_ON_OFF_RESULT(167),// v205
    CASHPET_SKILL_SETTING_RESULT(168),// v205
    CASH_LOOK_CHANGE_RESULT(169),// v205
    CASHPET_DYEING_RESULT(170), // v205
    SET_WEEK_EVENT_MESSAGE(171),// v205
    SET_POTION_DISCOUNT_RATE(172),// v205
    BRIDLE_MOB_CATCH_FAIL(173),// v205
    IMITATED_NPC_RESULT(174),// v205
    //idk
    IMITATED_NPC_DATA(176),// v205
    MONSTER_BOOK_SET_CARD(177),// v205
    MONSTER_BOOK_SET_COVER(178),// v205
    HOUR_CHANGE(179),// v205
    MINIMAP_ON_OFF(180),// v205
    CONSULT_AUTH_KEY_UPDATE(181),// v205
    CLASS_COMPETITION_AUTH_KEY_UPDATE(182),// v205
    WEB_BOARD_AUTH_KEY_UPDATE(183),// v205
    SESSION_VALUE(184),// v205
    PARTY_VALUE(185),// v205
    FIELD_SET_VARIABLE(186),// v205
    FIELD_VALUE(187),// v205
    BONUS_EXP_RATE_CHANGED(188),// v205
    NOTIFY_LEVEL_UP(189),// v205
    NOTIFY_WEDDING(190), // v205
    NOTIFY_JOB_CHANGE(191), // v205
    SET_BUY_EQUIP_EXT(192), // v205
    SET_PASSENSER_REQUEST(193), // v205
    SCRIPT_PROGRESS_MESSAGE_BY_SOUL(194), // v205
    SCRIPT_PROGRESS_MESSAGE(195), // v205
    SCRIPT_PROGRESS_ITEM_MESSAGE(196), // v205
    STATIC_SCREEN_MESSAGE(197), // v205
    OFF_STATIC_SCREEN_MESSAGE(198), // v205
    WEATHER_EFFECT_NOTICE(199), // v205
    WEATHER_EFFECT_NOTICE_Y(200), // v205
    UNK199(199),
    //
    //
    //
    PROGRESS_MESSAGE_FONT(203), // v205
    DATA_CRC_CHECK_FAILED(-1),
    SHOW_SLOT_MESSAGE(-1),
    WILD_HUNTER_INFO(205), // v205
    ZERO_INFO(206), // v205
    ZERO_WP(207), // v205
    ZERO_INFO_SUB_HP(208),
    UI_OPEN(209),
    CLEAR_ANNOUNCED_QUEST(210),
    RESULT_INSTANCE_TABLE(211),
    COOL_TIME_SET(212),
    ITEM_POT_CHANGE(214),
    SET_ITEM_COOL_TIME(215),
    SET_AD_DISPLAY_INFO(216),
    SET_AD_DISPLAY_STATUS(-1),
    SET_SON_OF_LINKED_SKILL_RESULT(217),
    SON_OF_LINKED_SKILL_MESSAGE(218),
    UNK216(-1),
    UNK217(-1),
    SET_MAPLE_STYLE_INFO(221),
    UPDATE_UI_EVENT_LIST_INFO(226),
    DOJANG_RANKING_RESULT(227),
    SHUTDOWN_MESSAGE(-1),
    RESULT_SET_STEAL_SKILL(231),
    SLASH_COMMAND(232),
    START_NAVIGATION(233),
    FUNCKEY_SET_BY_SCRIPT(235),
    CHARACTER_POTENTIAL_SET(236),
    CHARACTER_POTENTIAL_RESET(237),
    CHARACTER_HONOR_EXP(238),
    READY_FOR_RESPAWN(239),
    READY_FOR_RESPAWN_BY_POINT(240),
    OPEN_READY_FOR_RESPAWN_UI(241),
    CHARACTER_HONOR_GIFT(242),
    CROSS_HUNTER_COMPLETE_RESULT(243),
    CROSS_HUNTER_SHOP_RESULT(244),
    UNK241(241),
    SET_CASH_ITEM_NOTICE(246),
    SET_SPECIAL_CASH_ITEM(247),
    SHOW_EVENT_NOTICE(248),
    BOARD_GAME_RESULT(249),
    YUT_GAME_RESULT(250),
    VALUE_PACK_RESULT(251),
    NAVI_FLYING_RESULT(252),
    SET_EXCL_REQUEST_SENT(253),
    CHECK_WEDDING_EX_RESULT(254),
    BINGO_RESULT(255),
    BINGO_CASSANDRA_RESULT(256),
    UPDATE_VIP_GRADE(257),
    MESO_RANGER_RESULT(258),
    SET_MAPLE_POINT(259),
    SET_MIRACLE_TIME_INFO(260),
    HYPER_SKILL_RESET_RESULT(261),
    GET_SERVER_TIME(263),
    GET_CHARACTER_POSITION(265),
    RETURN_EFFECT_CONFIRM(268),
    RETURN_EFFECT_MODIFIED(269),
    WHITE_ADDTIONAL_CUBE_RESULT(270),
    BLACK_CUBE_RESULT(271),
    MEMORIAL_CUBE_RESULT(272),
    MEMORIAL_CUBE_MODIFIED(273),
    DRESS_UP_INFO_MODIFIED(276),
    UNK273(273),
    RESET_STATE_FOR_OFF_SKILL(279),
    SET_OFF_STATE_FOR_OFF_SKILL(280),
    ISSUE_RELOGIN_COOKIE(281),
    AVATAR_PACK_TEST(282),
    EVOLVING_RESULT(283),
    ACTION_BAR_RESULT(284),
    GUILD_SEARCH_RESULT(285),
    HALLOWEEN_CANDY_RANKING_RESULT(287),
    GET_REWARD_RESULT(289),
    MENTORING(290),
    GET_LOTTERY_RESULT(291),
    CHECK_PROCESS_RESULT(292),
    COMPLETE_NPC_SPEECH_SUCCESS(293),
    COMPLETE_SPECIAL_CHECK_SUCCESS(294),
    SET_ACCOUNT_INFO(295),
    SET_GACHAPFEVER_TIME_INFO(-1),
    AVATAR_MEGAPHONE_RES(296),
    SET_AVATAR_MEGAPHONE(297),
    CLEAR_AVATAR_MEGAPHONE(298),
    REQUEST_EVENT_LIST(300),
    LIKE_POINT(301),
    SIGN_ERROR_ACK(302),
    ASK_AFTER_ERROR_ACK(-1),
    EVENT_NAME_TAG(303),
    ACQUIRE_EVENT_NAME_TAG(304),
    JOB_FREE_CHANGE_RESULT(305),
    EVENT_LOTTERY_OPEN(306),
    EVENT_LOTTERY_RESULT(307),
    UNK304(-1),
    UNK305(-1),
    UNK306(-1),
    UNK307(-1),
    UNK308(-1),
    UNK309(-1),
    UNK310(-1),
    UNK311(-1),
    UNK312(-1),
    SCREEN_MSG(-1),
    MONSTER_BATTLE_SYSTEM_RESULT(-1),
    MONSTER_BATTLE_COMBAT_RESULT(-1),
    UNIVERSE_BOSS_IMPOSSIBLE(-1),
    CASH_SHOP_PREVIEW_INFO(-1),
    CHANGE_SOUL_COLLECTION_RESULT(-1),
    SELECT_SOUL_COLLECTION_RESULT(-1),
    MASTER_PIECE_REWARD(-1),
    PENDANT_SLOT_INC_RESULT(-1),
    BOSS_ARENA_MATCH_SUCCESS(-1),
    BOSS_ARENA_MATCH_FAIL(-1),
    BOSS_ARENA_MATCH_REQUEST_DONE(-1),
    USER_SOUL_MATCHING(-1),
    CATAPULT_UPGRADE_SKILL(-1),
    CATAPULT_RESET_SKILL(-1),
    PARTY_QUEST_RANKING_RESULT(-1),
    SET_COORDINATION_CONTEST_INFO(-1),
    WORLD_TRANSFER_RESULT(-1),
    UNK331(-1),
    ELITE_MOB_WMI(-1),
    RANDOM_PORTAL_NOTICE(-1),
    NOTIFY_WORLD_TRANSFER_HELPER(-1),
    UNK335(-1),
    EQUIPMENT_ENCHANT(340),
    TOP_TOWER_RANK_RESULT(-1),
    FRIEND_TOWER_RANK_RESULT(-1),
    TOWER_RESULT_UI_OPEN(-1),
    MANNEQUIN_RESULT(-1),
    UNK341(-1),
    UNK342(-1),
    IRBOX_PACKET(-1),
    CREATE_KOREAN_JUMPING_GAME(-1),
    CREATE_SWING_GAME(-1),
    UPDATE_MAPLE_TV_SHOW_TIME(-1),
    RETURN_TO_TITLE(351),
    RETURN_TO_CHARACTER_SELECT(352),
    FLAME_WIZARD_FLAME_WALK_EFFECT(-1),
    FLAME_WIZARD_FLARE_BLINK(-1),
    SUMMONED_AVATAR_SYNC(-1),
    CASH_SHOP_EVENT_INFO(-1),
    BLACK_LIST(-1),
    OPEN_UI_TEST(-1),
    SWITCH_BLACK_LIST_VIEW(-1),
    SCROLL_UPGRADE_FEVER_TIME(-1),
    TEXT_EQUIP_INFO(-1),
    TEXT_EQUIP_UI_OPEN(-1),
    UI_STAR_PLANET_MINI_GAME_RESULT(-1),
    UI_STAR_PLANET_TREND_SHOP(-1),
    UI_STAR_PLANET_MINI_GAME_QUEUE(-1),
    UNK362(-1),
    STAR_PLANET_ROUND_INFO(-1),
    STAR_PLANET_RESULT(-1),
    UNK365(-1),
    UNK366(-1),
    UNK367(-1),
    UNK368(-1),
    UNK369(-1),// new v203.2
    BACK_SPEED_CTRL(-1),
    SET_MAZE_AREA(-1),
    CHARACTER_BURNING(-1),
    BATTLE_STAT_CORE_INFO(-1),
    BATTLE_STAT_CORE_ACK(-1),
    GACHAPTEST_RESULT(-1),
    MASTER_PIECE_TEST_RESULT(-1),
    ROYAL_STYLE_TEST_RESULT(-1),
    BEAUTY_COUPTEST_RESULT(-1),
    LUNA_CRYSTAL_TEST_RESULT(-1),
    NICK_SKILL_EXPIRED(-1),
    RANDOM_MISSION_RESULT(385),
    ON_12TH_TRESURE_RESULT(-1),
    ON_12TH_TRESURE_BUFF(-1),
    ITEM_COLLECTION_RESULT(-1),
    CHECK_COLLECTION_COMPLETE_RESULT(-1),
    ITEM_COLLECTION_LIST(-1),
    RECEIVE_TOADS_HAMMER_REQUEST_RESULT(-1),
    RECEIVE_HYPER_STAT_SKILL_RESET_RESULT(392),
    UNK389(-1),
    INVENTORY_OPERATION_RESULT(-1),
    SET_ROLE_PLAYING_CHARACTER_INFO(-1),
    MVP_ALARM(-1),
    MONSTER_COLLECTION_RESULT(397),
    TOWER_CHAIR_SETTING_RESULT(-1),
    NEED_CLIENT_RESPONSE(-1),
    CHARACTER_MODIFIED(-1),
    UNK397(-1),
    UNK398(-1),
    TRADE_KING_SHOP_ITEM(-1),
    TRADE_KING_SHOP_RES(-1),
    PLAT_FORMAR_ENTER_RESULT(-1),
    PLAT_FORMAR_OXYZEN(-1),
    ITEM_RECYCLE_RESULT(-1),
    UNK404(-1),
    VMATRIX_UPDATE(409),
    NODE_STONE_RESULT(410),
    NODE_ENHANCE_RESULT(411),
    NODE_SHARD_RESULT(412),
    NODE_CRAFT_RESULT(413),
    UNK410(-1),
    UNK411(-1),
    UNK412(-1),
    UNK413(-1),
    UNK414(-1),
    UNK415(-1),
    UNK416(-1),
    UNK417(-1),
    UNK418(-1),
    UNK419(-1),
    UNK420(-1),
    UNK421(-1),
    UNK422(-1),
    UNK423(-1),
    UNK424(-1),
    UNK425(-1),
    UNK426(-1),
    UNK427(-1),
    UNK428(-1),
    UNK429(-1),
    UNK430(-1),
    UNK431(-1),
    UNK432(-1),
    UNK433(-1),
    UNK434(-1),
    UNK435(-1),
    UNK436(-1),
    UNK437(-1),
    UNK438(-1),
    UNK439(-1),
    UNK440(-1),
    UNK441(-1),
    UNK442(-1),
    UNK443(-1),// new v203.2
    UNK444(-1),
    UNK445(-1),
    UNK446(-1),
    UNK447(-1),
    UNK448(-1),
    UNK449(-1),
    UNK450(-1),
    UNK451(-1),
    UNK452(-1),
    USER_GENDER_RESULT(-1),
    GUILD_BBS_RESULT(477),
    UNK455(-1),
    UNK456(-1),
    UNK457(-1),
    UNK458(-1),
    UNK459(-1),
    UNK460(-1),
    MONSTER_BOOK_CARD_DATA(-1),
    UNK462(-1),
    UNK463(-1),
    UNK464(-1),
    UNK465(-1),
    UNK466(-1),
    UNK467(-1),
    GM_POLICE(-1),
    UNK469(-1),
    UNK470(-1),
    UNK471(-1),
    UNK472(-1),
    UNK473(-1),
    UNK474(-1),
    UNK475(-1),
    UNK476(-1),
    UNK477(-1),
    UNK478(-1),
    UNK479(-1),
    UNK480(-1),
    UNK481(-1),
    UNK482(-1),
    UNK483(-1),
    UNK484(-1),
    UNK485(-1),
    UNK486(-1),
    UNK487(-1),
    MAGIC_WHEEL_RESULT(-1),
    HOT_TIME_REWARD_RESULT(-1),
    UNK490(-1),
    UNK491(-1),
    UNK492(-1),
    UNK493(-1),
    RREMOVE_DAMAGE_SKIN_RESULT(-1),
    UNK495(-1),
    SET_GACHAPON_FEVER_TIME_INFO(-1),
    UNK497(-1),
    UNK498(-1),
    UNK499(-1),
    UNK500(-1),
    UNK501(-1),
    UNK502(-1),
    UNK503(-1),
    UNK504(-1),
    UNK505(-1),
    UNK506(-1),// new v203.2
    UNK507(-1),// new v203.2
    MACRO_SYS_DATA_INIT(530), // v205

    // CStage::OnPacket
    SET_FIELD(531),
    SET_FARM_FIELD(532),
    SET_AUCTION_FIELD(533),// v203.2
    UNK512(512),
    SET_CASH_SHOP(535),

    // CField::OnPacket
    TRANSFER_FIELD_REQ_IGNORED(536),
    TRANSFER_CHANNEL_REQ_IGNORED(537),
    TRANSFER_PVP_REQ_IGNORED(538),
    FIELD_SPECIFIC_DATA(539),
    GROUP_MESSAGE(540),
    GROUP_MESSAGE_2(541),
    FIELD_UNIVERSE_MESSAGE(542),
    WHISPER(543),
    SUMMITEM_INAVAILABLE(544),
    FIELD_EFFECT(545),
    WEDDING_MESSAGE(546),
    UNK525(547),
    UNK526(548),
    UNK527(549),
    UNK528(550),
    UNK529(551),
    DEBUFF_OBJ_ON_2(552),
    BLOW_WEATHER(553),
    PLAY_JUKE_BOX(554),
    ADMIN_RESULT(555),
    QUIZ(556),
    FIELD_SET_DESC(5557),
    CLOCK(559),
    SET_QUEST_CLEAR(562),
    SET_QUEST_TIME(563),
    SET_OBJECT_STATE(564),
    ARIANT_ARENA_SHOW_RESULT(682),
    STALK_RESULT(576),
    MASSACRE_INC_GAUGE(-1),
    MASSACRE_RESULT(-1),
    INIT(-1),
    FOOT_HOLD_MOVE(-1),
    CORRECT_FOOT_HOLD_MOVE(-1),
    DYNAMIC_OBJ_MOVE(-1),
    DYNAMIC_OBJ_SHOW_HIDE(-1),
    DYNAMIC_OBJ_URSUS_SYNC(-1),
    UNK555(-1),
    FIELD_KILL_COUNT(-1),
    SMART_MOB_NOTICE(-1),
    CHANGE_PHASE(-1),
    CHANGE_MOB_ZONE(-1),
    MOB_ORDER_FROM_SVR(-1),
    PV_P_MIGRATE_INFO_RESULT(-1),
    CUR_NODE_EVENT_END(584),
    CREATE_FORCE_ATOM(585),
    ARK_CREATE_FORCE_ATOM(586),
    UNK565(-1),
    UNK566(-1),
    SET_ACHIEVE_RATE(-1),
    SET_QUICK_MOVE_INFO(590), // v205
    CREATE_OBTACLE(591),
    //
    CLEAR_OBTACLE(593),
    B2_FOOT_HOLD_CREATE(-1),
    DEBUFF_OBJ_ON(-1),
    CREATE_FALLING_CATCHER(-1),
    CHASE_EFFECT_SET(-1),
    MESO_EXCHANGE_RESULT(-1),
    SET_MIRROR_DUNGEINFO(-1),
    SET_INTRUSION(-1),
    CANNOT_DROP(-1),
    FOOT_HOLD_OFF(-1),
    LADDER_ROPE_OFF(-1),
    MOMENT_AREA_OFF(-1),
    MOMENT_AREA_OFF_ALL(-1),
    CHAT_LET_CLIENT_CONNECT(-1),
    CHAT_INDUCE_CLIENT_CONNECT(-1),
    PACKET(-1),
    ELITE_STATE(609),
    PLAY_SOUND(-1),
    STACK_EVENT_GAUGE(-1),
    SET_UNIFIELD(-1),
    STAR_PLANET_BURNING_TIME_INFO(-1),
    UNK592(-1),
    UNK593(-1),
    UNK594(-1),
    UNK595(-1),
    UNK596(-1),
    UNK597(-1),
    PUBLIC_SHARE_STATE(-1),
    FUNCTION_TEMP_BLOCK(-1),
    UI_STATUS_BAR_PACKET(-1),
    FIELD_SKILL_DELAY(-1),
    UNK602(-1),
    UNK603(-1),
    UNK604(-1),
    WEATHER_PACKET_ADD(-1),
    WEATHER_PACKET_REMOVE(-1),
    WEATHER_PACKET_MSG(-1),
    ADD_WRECKAGE(630),
    DEL_WRECKAGE(631),
    CREATE_MIRROR_IMAGE(632),
    FUNCTION_FOOTHOLD_MAN(633),
    UNK612(612),
    UNK613(613),
    UNK614(614),
    UNK615(615),
    UNK616(616),
    UNK617(617),
    UNK618(618),
    UNK619(619),
    UNK620(620),
    UNK621(621),
    UNK622(622),
    UNK623(623),
    UNK624(624),// new v203.2

    // CUserPool::OnPacket
    USER_ENTER_FIELD(651),
    USER_LEAVE_FIELD(652),

    // CUserPool::OnCommonPacket
    CHAT(653),
    AD_BOARD(654),
    UNK629(655),
    MINI_ROOM_BALLOON(656),
    SET_CONSUME_ITEM_EFFECT(657),
    SHOW_ITEM_UPGRADE_EFFECT(658),
    SHOW_ITEM_SKILL_SOCKET_UPGRADE_EFFECT(660),
    SHOW_ITEM_SKILL_OPTION_UPGRADE_EFFECT(661),
    SHOW_ITEM_RELEASE_EFFECT(662),
    SHOW_ITEM_UNRELEASE_EFFECT(663),
    SHOW_ITEM_LUCKY_ITEM_EFFECT(664),
    SHOW_ITEM_MEMORIAL_EFFECT(665),
    SHOW_ITEM_ADDITIONAL_UN_RELEASE_EFFECT(666),
    SHOW_ITEM_ADDITIONAL_SLOT_EXTEND_EFFECT(667),
    SHOW_ITEM_FIRE_WORKS_EFFEC(668),
    SHOW_ITEM_OPTION_CHANGE_EFFECT(669),
    RED_CUBE_RESULT(670),
    ADDITIONAL_CUBE_RESULT(671),
    HIT_BY_USER(672),
    DOT_BY_USER(673),
    RESET_ALL_DOT(674),
    DAMAGE_BY_USER(675),
    TESLA_TRIANGLE(676),
    FOLLOW_CHARACTER(677),
    SHOW_PQ_REWARD(678),
    SET_ONE_TIME_ACTION(679),
    MAKING_SKILL_RESULT(680),
    SET_MAKING_MEISTER_SKILL_EFF(681),
    GATHER_RESULT(682),
    USER_EXPLODE(683),
    USER_HIT_BY_COUNTER(684),
    PYRAMID_LETHAL_ATTACK(685),
    MIXER_RESULT(686),
    WAIT_QUEUE_RESPONSE(687),
    CATEGORY_EVENT_NAME_TAG(688),
    UNK663(689),
    SET_DAMAGE_SKIN(690),
    SET_PREMIUM_DAMAGE_SKIN(691), // v205
    SET_SOUL_EFFECT(693),
    SIT_RESULT(694),
    STAR_PLANET_POINT_INFO(695),
    STAR_PLANET_AVATAR_LOOK_SET(696),
    TOSSED_BY_MOB_SKILL(697),
    BATTLE_ATTACK_HIT(698),
    BATTLE_USER_HIT_BY_MOB(699),
    //idk
    FREEZE_HOT_EVENT_INFO(701),
    EVENT_BEST_FRIEND_INFO(702),
    SET_REPEAT_ONE_TIME_ACTION(703),
    SET_REPLACE_MOVE_ACTION(704),
    IN_GAME_CUBE_RESULT(705),
    //
    //
    //
    SET_ACTIVE_EMOTICON_ITEM(708),
    //
    CREATE_PSYCHIC_LOCK(710),
    RECREATE_PATHPSYCHIC_LOCK(711),
    RELEASE_PSYCHIC_LOCK(712),
    RELEASE_PSYCHIC_LOCK_MOB(713),
    CREATE_PSYCHIC_AREA(714),
    RELEASE_PSYCHIC_AREA(715),
    BEAST_FORM_WING_OFF(717),
    SET_MESO_CHAIR_COUNT(720),
    REFRESH_NAME_TAG_MARK(721),
    STIGMA_EFFECT(725),

    GACHAPON_EFFECT(767),


    // CUser::OnPetPacke
    PET_ACTIVATED(733),
    PET_MOVE(734),
    PET_ACTION(735),
    PET_ACTION_SPEAK(736),
    PET_NAME_CHANGED(737),
    PET_LOAD_EXCEPTION_LIST(738),
    PET_HUE_CHANGED(739),
    PET_MODIFIED(740),
    PET_ACTION_COMMAND(741),

    // CUser::OnDragonPacket
    DRAGON_CREATED(744),
    DRAGON_MOVE(745),
    DRAGON_REMOVE(746),
    DRAGON_REMOVE_RP_CHAR(747),

    // CUser::OnAndroidPacket
    ANDROID_CREATED(748),
    ANDROID_MOVE(749),
    ANDROID_ACTION_SET(750),
    ANDROID_MODIFIED(751),
    ANDROID_REMOVED(752),

    // CUser::OnFoxManPacket
    FOX_MAN_ENTER_FIELD(753),
    FOX_MAN_MOVE(754),
    FOX_MAN_EXCL_RESULT(755),
    FOX_MAN_SHOW_CHANGE_EFFECT(756),
    FOX_MAN_MODIFIED(757),
    FOX_MAN_LEAVE_FIELD(758),

    // CUser::OnSkillPetPacket
    SKILL_PET_MOVE(760),
    SKILL_PET_ACTION(761),
    SKILL_PET_STATE(762),
    SKILL_PET_NAME_CHANGED(763),
    SKILL_PET_LOAD_EXCEPTION_LIST(764),
    SKILL_PET_TRANSFER_FIELD(765),

    // CFamiliar::OnPacket
    FAMILIAR_ENTER_FIELD(778),
    FAMILIAR_MOVE(779),
    FAMILIAR_HIT(780),
    FAMILIAR_ATTACK(781),
    FAMILIAR_RENAME(782),
    FAMILIAR_TRANSFER_FIELD(783),
    FAMILIAR_UPDATE_INFO(784),

    // CUserRemote::OnPacket
    REMOTE_MOVE(789),
    REMOTE_MELEE_ATTACK(790),
    REMOTE_SHOOT_ATTACK(791),
    REMOTE_MAGIC_ATTACK(792),
    REMOTE_BODY(793),
    REMOTE_SKILL_PREPARE(794),
    REMOTE_MOVING_SHOOT_ATTACK_PREPARE(795),
    REMOTE_SKILL_CANCEL(796),
    REMOTE_HIT(797),
    REMOTE_EMOTION(798),
    REMOTE_ANDROID_EMOTION(799),
    REMOTE_SET_ACTIVE_EFFECT_ITEM(800),
    REMOTE_SET_MONKEY_EFFECT_ITEM(801),
    REMOTE_SET_ACTIVE_NICK_ITEM(802),
    REMOTE_SET_DEFAULT_WING_ITEM(803),
    REMOTE_SET_KAISER_TRANSFORM_ITEM(804),
    REMOTE_SET_CUSTOM_RIDING(805),
    REMOTE_SHOW_UPGRADE_TOMB_EFFECT(806),
    REMOTE_SET_ACTIVE_PORTABLE_CHAIR(807),
    REMOTE_AVATAR_MODIFIED(808),
    REMOTE_EFFECT(809),
    REMOTE_SET_TEMPORARY_STAT(810),
    REMOTE_RESET_TEMPORARY_STAT(811),
    REMOTE_RECEIVE_HP(812),
    REMOTE_GUILD_NAME_CHANGED(813),
    REMOTE_GUILD_MARK_CHANGED(814),
    REMOTE_PVP_TEAM_CHANGED(815),
    REMOTE_GATHER_ACTION_SET(816),
    REMOTE_UPDATE_PVP_HP_TAG(817),
    REMOTE_DRAGON_GLIDE(818),
    REMOTE_KEY_DOWN_AREA_MOVE_PATH(819),
    REMOTE_LASER_INFO_FOR_REMOTE(820),
    REMOTE_KAISER_COLOR_OR_MORPH_CHANGE(821),
    REMOTE_DESTROY_GRENADE(822),
    REMOTE_SET_ITEM_ACTION(823),
    REMOTE_ZERO_TAG(824),
    REMOTE_INTRUSION(825),
    REMOTE_ZERO_LAST_ASSIST_STATE(826),
    REMOTE_SET_MOVE_GRENADE(827),
    UNK799(828),
    UNK800(829),
    REMOTE_RUNE_STONE_ACTION(830),
    REMOTE_KINESIS_PSYCHIC_ENERGY_SHIELD_EFFECT(831),
    REMOTE_DRAGON_ACTION(832),
    REMOTE_DRAGON_BREATH_EARTH_EFFECT(833),
    REMOTE_RELEASE_RW_GRAB(834),
    REMOTE_RW_MULTI_CHARGE_CANCEL_REQUEST(835),
    REMOTE_SCOUTER_MAX_DAMAGE_UPDATE(836),
    REMOTE_STIGMA_DELIVERY_RESPONSE(837),
    REMOTE_SHOOT_OBJECT(838),
    UNK809(809),
    UNK810(810),
    UNK811(811),
    UNK812(812),
    UNK813(813),
    UNK814(814),
    REMOTE_THROW_GRENADE(844),

    // CUserLocal::OnPacket
    EMOTION(845),
    ANDROID_EMOTION(846),
    EFFECT(847),
    TELEPORT(848),
    MESO_GIVE_SUCCEEDED(850),
    MESO_GIVE_FAILED(851),
    QUEST_RESULT(852),
    NOTIFY_HP_DEC_BY_FIELD(853),
    USER_PET_SKILL_CHANGED(854),
    BALLOON_MSG(855),
    PLAY_EVENT_SOUND(856),
    PLAY_MINIGAME_SOUND(857),
    MAKER_RESULT(858),
    OPEN_CLASS_COMPETION_TIPAGE(860),
    OPEN_UI(861),
    CLOSE_UI(862),
    OPEN_UI_WITH_OPTION(863),
    SET_DIRECTION_MODE(864),
    SET_IN_GAME_DIRECTION_MODE(865),
    SET_STAND_ALONE_MODE(866),
    HIRE_TUTOR(867),
    TUTOR_MSG(868),
    HIRE_TUTOR_BY_ID(869),
    SET_PARTNER(870),
    //idk
    SET_PARTNER_ACTION(872),
    SET_PARTNER_FORCE_FLIP(873),
    SWITCH_RP(874),
    MOD_COMBO_RESPONSE(875),
    INC_COMBO_RESPONSE_BY_COMBO_RECHARGE(876),
    RADIO_SCHEDULE(877),
    OPEN_SKILL_GUIDE(878),
    NOTICE_MSG(879),
    CHAT_MSG(880),
    SET_UTIL_DLG(881),
    BUFFZONE_EFFECT(882),
    TIME_BOMB_ATTACK(883),
    EXPLOSION_ATTACK(884),
    PASSIVE_MOVE(885),
    FOLLOW_CHARACTER_FAILED(886),
    SET_NEXT_SHOOT_EX_JABLIN(887),
    CREATE_NEW_CHARACTER_RESULT__PREMIUM_ADVENTURER(888),
    GATHER_REQUEST_RESULT(889),
    RUNE_STONE_USE_ACK(890),
    BAG_ITEM_USE_RESULT(891),
    RANDOM_TELEPORT_KEY(892),
    SET_GAGE_POINT(893),
    IN_GAME_DIRECTION_EVENT(895),
    MEDAL_REISSUE_RESULT(896),
    DODGE_SKILL_READY(897),
    REMOVE_MICRO_BUFF_SKILL(898),
    VIDEO_BY_SCRIPT(899),
    //idk
    REWARD_MOB_LIST_RESULT(901),
    INC_JUDGEMENT_STACK_RESPONSE(902),
    INC_CHARM_BY_CASHP_R_MSG(903),
    SET_BUFF_PROTECTOR(904),
    INC_LARKNESS_RESPONSE(905),
    DETONATE_BOMB(906),
    AGGRO_RANK_INFO_NAME(907),
    DEATH_COUNT_INFO(908),
    INDIVIDUAL_DEATH_COUNT_INFO(909),
    SET_DRESS_CHANGED(910),
    SERVER_ACK_MOB_ZONE_STATE_CHANGE(911),
    RANDOM_EMOTION(914),
    SET_FLIP_THE_COIN_ENABLED(915),
    TRICK_OR_TREAT_RESULT(916),
    GIANT_PET_BUFF(917),
    B2_BODY_RESULT(918),
    //idk
    SET_DEAD(920),
    OPEN_UI_DEAD(921),
    EXPIRED_NOTICE(922),
    DO_LOTTERY_UI(923),
    ROULETTE_START(924),
    SIT_TIME_CAPSULE(925),
    SIT_DUMMY_PORTABLE_CHAIR(926),
    GO_MONSTER_FARM(927),
    MONSTER_LIFE_INVITE_ITEM_RESULT(928),
    PHOTO_GET_RESULT(929),
    FINAL_ATTACK_REQUEST(930),
    SET_GUN(931),
    SET_AMMO(932),
    CREATE_GUN(933),
    CLEAR_GUN(934),
    RESULT_SHOOT_ATTACK_IN_FPS_MODE(935),
    MIRROR_DUNGEENTER_FAIL(936),
    MIRROR_DUNGEUNIT_CLEARED(937),
    REGISTER_MIRROR_DUNGEBOSS(938),
    MIRROR_DUNGERECORD(939),
    OPEN_URL(940),
    ZERO_COMBAT_RECOVERY(-1),
    MIRROR_STUDY_UI_OPEN(-1),
    SKILL_COOLTIME_REDUCE(-1),
    MIRROR_READING_UI_OPEN(-1),
    USER_CTRL_MOB_SKILL_Q_PUSH(-1),
    ZERO_LEVEL_UP_ALARM(-1),
    USER_CTRL_MOB_SKILL_Q_POP(-1),
    USER_CTRL_MOB_SKILL_FAIL(-1),
    FORCE_SUMMONED_REMOVE(-1),
    USER_RESPAWN(-1),
    USER_CTRL_MOB_SKILL_FORCED_POP(-1),
    IS_UNIVERSE(-1),
    PORTAL_GROUP(-1),
    SET_MOVABLE(-1),
    USER_CTRL_MOB_SKILL_PUSH_COOL_TIME(-1),
    MOVE_PARTICLE_EFF(956),
    DO_ACTIVE_EVENT_SKILL_BY_SCRIPT(957),
    SET_STATUSBAR_JOB_NAME_BLUR(958),
    RUNE_STONE_SKILL_ACK(959),
    RESET_RUNE_STONE_ACTION(960),
    MOVE_TO_CONTENTS_CANNOT_MIGRATE(961),
    // idk
    PLAY_AMBIENT_SOUND(963),
    STOP_AMBIENT_SOUND(964),
    FLAME_WIZARD_ELEMENT_FLAME_SUMMON(965),
    CAMERA_MODE(966),
    SPOTLIGHT_TO_CHARACTER(967),
    BOSS_PARTY_CHECK_DONE(968),
    FREE_LOOK_CHANGE_UI_OPEN(969),
    FREE_LOOK_CHANGE_SUCCESS(970),
    GRAY_BACKGROUND(971),
    GET_NPC_CURRENT_ACTION(972),
    CAMERA_ROTATION(973),
    CAMERA_SWITCH(974),
    NETWORK(975),
    USER_SET_FIELD_FLOATING(976),
    ADD_POPUP_SAY(977),
    REMOVE_POPUP_SAY(978),
    JAGUAR_SKILL(979),
    ACTION_LAYER_RELMOVE(980),
    // idk
    SEND_CLIENT_RESOLUTION(982),
    USER_BONUS_ATTACK_REQUEST(983),
    USER_RAND_AREA_ATTACK_REQUEST(984),
    // idk
    JAGUAR_ACTIVE(986),
    SKILL_COOLTIME_SET_M(987),
    SET_CARRY_REACTOR_INFO(-1),
    REACTOR_SKILL_USE_REQUEST(-1),
    OPEN_BATTLE_PV_PCHAMP_SELECT_UI(-1),
    BATTLE_PVP_ITEM_DROP_SOUND(-1),
    SET_MESO_COUNT_BY_SCRIPT(-1),
    PLANT_POT_CLICK_RESULT(-1),
    PLANT_POT_EFFECT(-1),
    UNK966(-1),
    DAMAGE(-1),
    ROYAL_GUARD_ATTACK(998),
    DO_ACTIVE_PSYCHIC_AREA(999),
    ENTER_FIELD_PSYCHIC_INFO(1000),
    LEAVE_FIELD_PSYCHIC_INFO(1001),
    TOUCH_ME_STATE_RESULT(1002),
    FIELD_SCORE_UPDATE(1003),
    URUS_REUSLT_UI_OPEN(1004),
    URUS_NO_MORE_LIFE(1005),
    REGISTER_TELEPORT(1006),
    UNK977(1007),
    UNK978(1008),
    CREATE_AREA_DOT_INFO(1009),
    UNK980(1010),
    UNK981(1011),
    SET_SLOW_DOWN(1012),
    REGISTER_EXTRA_SKILL(1013),
    RES_WARRIOR_LIFT_MOB_INFO(1014),
    USER_RENAME_RESULT(1015),
    DAMAGE_SKIN_SAVE_RESULT(1016),
    STIGMA_REMAIN_TIME(1017),
    UNK988(1018),
    SHOOT_OBJECT_CREATED(1021), //v205
    USER_BURNING_RESULT(-1),
    UNK990(-1),
    SPEAR_OF_DARKNESS(-1),
    LIGHTNING_UNION_SUB_ATTACK_REQUEST(-1),
    SHADOW_SPEAR(-1),
    UNK994(-1),
    FINAL_FACT(-1),
    UNK996(-1),
    DARK_SERVANT_REQUEST(-1),
    UNK998(-1),
    UNK999(-1),
    TIDE_OF_BATTLE(-1),
    UNK1001(-1),
    UNK1002(-1),
    UNK1003(-1),
    FLOAT_NOTICE(-1),
    UNK1005(-1),
    UNK1006(-1),
    UNK1007(-1),
    UNK1008(-1),
    WRONG_2ND_PWD_RESULT(-1),
    VERTICAL_JUMP_REQUEST(-1),
    UNK1011(-1),
    UNK1012(-1),
    UNK1013(-1),
    UNK1014(-1),
    UNK1015(-1),
    DISCOVERY_SKY_GAUGE(-1),
    OPEN_MESO_SACK_SUCCESS(-1),
    OPEN_MESO_SACK_FAIL(-1),
    FAMILIAR_ADD_RESULT(1076),
    FAMILIAR_INVALID_NAME(1077),
    MOD_HAYATO_COMBO(1099),
    UNK1083(-1),// new v203.2
    UNK1084(-1),// new v203.2
    SKILL_COOLTIME_SET(1122),



    // CSummonedPool::OnPacket
    SUMMONED_CREATED(1124),
    SUMMONED_REMOVED(1125),
    SUMMONED_MOVE(1126),
    SUMMONED_ATTACK(1127),
    SUMMONED_ATTACK_PVP(1128),
    SUMMONED_SET_REFERENCE(1129),
    SUMMONED_SKILL(1130),
    SUMMONED_SKILL_PVP(1132),
    SUMMONED_UPDATE_HP_TAG(1133),
    SUMMONED_ATTACK_DONE(1134),
    SUMMONED_SET_RESIST(1135),
    SUMMONED_ACTION_CHANGE(1136),
    SUMMONED_ASSIST_ATTACK_REQUEST(1137),
    SUMMONED_SUMMON_ATTACK_ACTIVE(1138),
    SUMMONED_BEHOLDER_REVENGE_ATTACK(1139),
    UNK1103(-1),
    UNK1104(-1),
    UNK1105(-1),
    UNK1106(-1),
    UNK1107(-1),
    UNK1108(-1),
    UNK1109(-1),
    UNK1110(-1),
    UNK1111(-1),
    UNK1112(-1),
    UNK1113(-1),
    UNK1114(-1),
    UNK1115(-1),
    SUMMONED_HIT(1153),


    // CMobPool::OnPacket
    MOB_ENTER_FIELD(1154),
    MOB_LEAVE_FIELD(1155),
    MOB_CHANGE_CONTROLLER(1156),
    MOB_SET_AFTER_ATTACK(1157),
    MOB_BLOCK_ATTACK(1158),
    UNK1122(-1),
    UNK1123(-1),


    MOB_MOVE(1161),
    MOB_CONTROL_ACK(1162),
    MOB_STAT_SET(1164),
    MOB_STAT_RESET(1166),
    MOB_SUSPEND_RESET(1166),
    MOB_AFFECTED(1167),
    MOB_DAMAGED(1168),
    UNK1132(-1),
    UNK1133(-1),
    MOB_SPECIAL_EFFECT_BY_SKILL(1171),
    MOB_HP_CHANCE(-1),
    MOB_CRC_KEY_CHANGED(-1),
    MOB_CRC_DATA_REQUEST(-1),
    MOB_HP_INDICATOR(1175),
    MOB_CATCH_EFFECT(-1),
    MOB_STEAL_EFFECT(-1),
    MOB_EFFECT_BY_ITEM(-1),
    MOB_SPEAKING(-1),
    MOB_MESSAGING(-1),
    MOB_SKILL_DELAY(1181),
    ESCORT_FULL_PATH(1182),
    ESCORT_STOP_END_PERMISSION(1183),
    ESCORT_STOP_BY_SCRIPT(1184),
    ESCORT_STOP_SAY(1185),
    ESCORT_RETURN_BEFORE(1186),
    MOB_NEXT_ATTACK(1187),
    MOB_NEXT_ATTACK_2(-1),
    UNK1152(-1),
    UNK1153(-1),
    MOB_TELEPORT_REQUEST(1191),
    MOB_FORCED_ACTION(1192),
    MOB_FORCED_SKILL_ACTION(1193),
    UNK1157(1194),
    UNK1158(1195),
    MOB_TIME_RESIST(1196),
    MOB_ONEKILL_DAMAGE(1197),
    MOB_ATTACK_BLOCK(1198),
    MOB_ATTACK_PRIORITY(1199),
    MOB_ATTACK_TIME_INFO(-1),
    MOB_DAMAGE_SHARE_INFO_TO_LOCAL(-1),
    MOB_DAMAGE_SHARE_INFO_TO_REMOTE(-1),
    MOB_BREAK_DOWN_TIME_ZONE_TIME_OUT(-1),
    MOB_MOVE_AREA_SET(-1),
    MOB_DO_SKILL_BY_HIT(-1),
    MOB_CASTING_BAR_SKILL(1206),
    MOB_FLY_TARGET(-1),
    MOB_BOUNCE_ATTACK_SKILL(1208),
    MOB_AREA_INSTALL_BY_HIT(-1),
    MOB_LTRB_DAMAGE_SKILL(-1),
    MOB_SUMMSUB_BODY(-1),
    MOB_LASER_CONTROL(-1),
    UNK1176(-1),
    UNK1177(-1),
    UNK1178(-1),
    MOB_SCALE(-1),
    MOB_SPECIAL_ACTION(-1),
    MOB_PART_SYSTEM(-1),
    MOB_FORCE_CHASE(1219),
    MOB_HANG_OVER_REQUEST(-1),
    MOB_HANG_OVER_RELEASE_REQUEST(-1),
    MOB_DEAD_FPS_MODE(-1),
    MOB_AIR_HIT(-1),
    MOB_DEMIAN_DELAYED_ATTACK_CREATE(-1),
    MOB_REGISTER_REL_MOB_ZONE(-1),
    MOB_UNREGISTER_REL_MOB_ZONE(-1),
    MOB_NEXT_TARGET_FROM_SVR(-1),
    UNK1191(-1),
    UNK1192(-1),
    UNK1193(-1),
    UNK1194(-1),
    UNK1195(-1),
    UNK1196(-1),
    UNK1197(-1),
    UNK1198(-1),
    UNK1199(-1),
    UNK1200(-1),
    UNK1201(-1),
    UNK1202(-1),
    UNK1203(-1),
    UNK1204(-1),
    UNK1205(-1),
    UNK1206(-1),
    UNK1207(-1),
    UNK1208(-1),
    UNK1209(-1),
    UNK1210(-1),
    UNK1211(-1),
    UNK1212(-1),
    MOB_ATTACKED_BY_MOB(-1),
    UNK1214(-1),

    // CNpcPool::OnPacket
    NPC_ENTER_FIELD(1256),
    NPC_LEAVE_FIELD(1257),
    NPC_ENTER_FIELD_FOR_QUICK_MOVE(1258),
    NPC_CHANGE_CONTROLLER(1259),
    NPC_IMITATE_DATA(1260),
    NPC_UPDATE_LIMITED_DISABLE_INFO(1261),

    // CNpcPool::OnNpcPacket
    NPC_MOVE(1263),
    NPC_UPDATE_LIMITED_INFO(1264),
    NPC_SET_QUIZ_SCORE(1265),
    NPC_SET_QUIZ_SCORE_ANI(1266),
    NPC_SET_FORCE_MOVE(1267),
    NPC_SET_FORCE_FLIP(1268),
    NPC_SET_EMOTION(1269),
    NPC_SET_CHARACTER_BASE_ACTION(1270),
    NPC_VIEW_OR_HIDE(1271),
    NPC_PRESENT_ITEM_SET(1272),
    NPC_PRESENT_TIME_SET(1273),
    NPC_RESET_SPECIAL_ACTION(1274),
    NPC_SET_SCREEN_INFO(1275),
    NPC_LOCAL_NPC_REPEAT_EFFECT(1276),
    NPC_SET_NOTICE_BOARD_INFO(1277),
    //idk
    //idk
    //idk
    NPC_SET_SPECIAL_ACTION(1281),

    SET_NPC_SCRIPT(1262),

    // CField_MomentSwimArea::OnPacket
    MOMENT_SWIM_AREA_SET_WATER_LEVEL(1276),

    // CEmployeePool::OnPacket
    EMPLOYEE_ENTER_FIELD(1285),
    EMPLOYEE_LEAVE_FIELD(1286),
    EMPLOYEE_MINI_ROOM_BALLOON(1287),

    // CUnk::OnPacket
    UNK1246(1288),
    UNK1247(1289),
    UNK1248(1290),
    UNK1249(1291),
    UNK1250(1291),

    // CDropPool::OnPacket
    DROP_ENTER_FIELD(1292),
    UNK1293(1293),
    DROP_LEAVE_FIELD(1294),

    // CMessageBoxPool::OnPacket
    CREATE_MESSAGE_BOX_FAILED(1295),
    MESSAGE_BOX_ENTER_FIELD(1296),
    MESSAGE_BOX_LEAVE_FIELD(1297),

    // CAffectedAreaPool::OnPacket
    AFFECTED_AREA_CREATED(1298),
    INSTALLED_AREA_FIRE(1299),
    AFFECTED_AREA_REMOVED(1300),

    // CTownPortalPool::OnPacket
    TOWN_PORTAL_CREATED(1301),
    TOWN_PORTAL_REMOVED(1302),

    // CRandomPortalPool::OnPacket
    RANDOM_PORTAL_CREATED(1303),
    RANDOM_PORTAL_TRY_ENTER_REQUEST(1304),
    RANDOM_PORTAL_REMOVED(1305),

    // COpenGatePool::OnPacket
    OPEN_GATE_CREATED(1306),
    OPEN_GATE_CLOSE(1307),
    OPEN_GATE_REMOVED(1308),

    // CReactorPool::OnPacket
    REACTOR_CHANGE_STATE(1309),
    UNK1269(1310),
    REACTOR_ENTER_FIELD(1311),
    REACTOR_RESET_STATE(1312),
    REACTOR_OWNER_INFO(1313),
    REACTOR_REMOVE(1314),
    UNK1274(1315),
    UNK1275(1316),
    UNK1276(1317),
    UNK1277(1318),
    REACTOR_LEAVE_FIELD(1319),

    // CFishingZonePool::OnPacket
    FISHING_INFO(1320),
    FISHING_REWARD(1321),
    FISHING_ZONE_INFO(1322),

    // CPersonalMapObjectPool::OnPacket
    DECOMPOSER_ENTER_FIELD(1323),
    DECOMPOSER_LEAVE_FIELD(1324),

    // CUnk::OnPacket
    UNK1284(-1),
    UNK1285(-1),
    UNK1286(-1),
    UNK1287(-1),


    SNOW_BALL_STATE(-1),
    SNOW_BALL_HIT(-1),
    SNOW_BALL_MSG(-1),
    SNOW_BALL_TOUCH(-1),
    COCONUT_HIT(-1),
    COCONUT_SCORE(-1),
    GUILD_BOSS_HEALER_MOVE(-1),
    GUILD_BOSS_PULLEY_STATE_CHANGE(-1),
    MONSTER_CARNIVAL_CARNIVAL_ENTER(-1),
    MONSTER_CARNIVAL_PERSONAL_CP(-1),
    MONSTER_CARNIVAL_TEAM_CSCORE(-1),
    MONSTER_CARNIVAL_SPELL_COOLTIME(-1),
    MONSTER_CARNIVAL_RESULT_SUCCESS(-1),
    MONSTER_CARNIVAL_RESULT_FAIL(-1),
    MONSTER_CARNIVAL_DEATH(-1),
    MONSTER_CARNIVAL_MEMBER_OUT(-1),
    MONSTER_CARNIVAL_SHOW_GAME_RESULT(-1),
    MONSTER_CARNIVAL_UPDATE_RANK_INFO(-1),
    ARIANT_ARENA_USER_SCORE(-1),
    BATTLE_FIELD_ENTER(-1),
    BATTLE_FIELD_SCORE(-1),
    BATTLE_FIELD_TEAM_CHANGED(-1),
    WITCHTOWER_SCORE(-1),
    BOSS_SUMMON_TIMER(-1),
    PVP_FIELD_ENTER(-1),
    PVP_TEAM_CHANGE(-1),
    PVP_MODE_CHANGE(-1),
    PVP_STATE_CHANGE(-1),
    PVP_UPDATE_COUNT(-1),
    PVP_MODE_RESULT(-1),
    PVP_UPDATE_TEAM_INFO(-1),
    PVP_UPDATE_RANK_INFO(-1),
    PVP_HP_CHANGED(-1),
    PVP_TEAM_SCORE(-1),
    PVP_REVIVE_MESSAGE(-1),
    PVP_SCREEN_EFFECT(-1),
    PVP_ICE_KNIGHT_HP_CHANGE(-1),
    DEFENSE_WAVE(-1),
    DEFENSE_LIFE(-1),
    DEFENSE_POINT(-1),
    DEFENSE_SCORE_RANK(-1),
    DEFENSE_RESULT(-1),
    RANDOM_DROP_PICKED(-1),
    BROADCAST_RANDOM_DROP_PICKED(-1),
    BROADCAST_RANDOM_DROP_PHASE(-1),
    RANDOM_DROP_RESULT(-1),
    RANDOM_DROP_POINT_EFFECT(-1),
    PVP_HARD_CORE_MIGRATE(-1),
    PVP_HARD_CORE_DEAD(-1),
    PVP_HARD_CORE_KILL(-1),
    PVP_HARD_CORE_GAUGE(-1),
    PVP_HARD_CORE_FIELD_INFO(-1),
    PVP_HARD_CORE_ENTER(-1),
    PVP_HARD_CORE_FIELD_CHANGE(-1),
    PVP_HARD_CORE_SHUTDOWN(-1),
    PVP_HARD_CORE_CHAMPION_EFFECT(-1),
    MULTISTAGE_STAGE_SET(-1),
    MULTISTAGE_MOB_COUNT(-1),
    COOK_SET_RECIPES(-1),
    RHYTHM_GAME_INIT(-1),
    RHYTHM_GAME_USER_INFO(-1),
    RHYTHM_GAME_RESULT(-1),
    RHYTHM_GAME_REGION_RESULT(-1),
    RHYTHM_GAME_SPECIAL_ATTACK_RESULT(-1),
    RHYTHM_GAME_ATTACK_EFFECT(-1),
    RHYTHM_GAME_SPECIAL_MISSION_EFFECT(-1),
    RHYTHM_GAME_SPECIAL_ATTACK_EFFECT(-1),
    RHYTHM_GAME_SHOW_FEVER_EFFECT(-1),
    RHYTHM_GAME_SHOW_LONG_NOTE_EFFECT(-1),
    RHYTHM_GAME_SPECIAL_MISSION_SPOT_EFFECT(-1),
    RHYTHM_GAME_GAME_INFO(-1),
    MOUNTAIN_RIDING_HP_INFO(-1),
    MOUNTAIN_RIDING_UI_INFO(-1),
    MOUNTAIN_RIDING_MOB_INFO(-1),
    RHYTHM_GAME_USERNAME(-1),
    FIELD_RANK_CREATE(-1),
    FIELD_RANK_SET_USERNAME(-1),
    FIELD_RANK_RESULT(-1),
    PIRANHA_INIT(-1),
    PIRANHA_INFO(-1),
    PIRANHA_DIE(-1),
    FALLING_STONE_INIT(-1),
    FALLING_STONE_HP_INFO(-1),
    FALLING_STONE_POINT_EFFECT(-1),
    FALLING_STONE_USER_EXIT(-1),
    BATTLE_FIELD_SPECIAL_EFFECT(-1),
    BATTLE_FIELD_LIFE_SCORE(-1),
    BATTLE_FIELD_SHEEP_MORPH(-1),
    BATTLE_FIELD_DAMAGE_EFFECT(-1),
    BATTLE_FIELD_SHEEP_REVIVAL_EFFECT(-1),
    BATTLE_FIELD_SHEEP_REVIVAL_END(-1),
    BATTLE_FIELD_SHEEP_DEAD(-1),
    BATTLE_FIELD_GUID_MSG(-1),
    BATTLE_FIELD_USER_INIT(-1),
    BOSS_ARENA_FIELD_STATE_CHANGE(-1),
    BOSS_ARENA_CURRENT_TEAM_INFO(-1),
    BOSS_ARENA_SELECTED_TEAM_INFO(-1),
    BOSS_ARENA_SELECT_OPPONENT_SELECT_BOSS(-1),
    BOSS_ARENA_SELECT_OPPONENT_CONFIRM(-1),
    HEKATON_DO_SKILL(-1),
    HEKATON_READY_SKILL(-1),
    HEKATON_RANKING_INFO(-1),
    HEKATON_RESULT(-1),
    UNIVERSE_BOSS_HP_INFO(-1),
    BOSS_ARENA_SCORE(-1),
    BOSS_ARENA_RESULT_INFO(-1),
    BOSS_ARENA_FADE_IN_OUT(-1),
    BOSS_ARENA_SUMMON_HEAD_GEAR(-1),
    BOSS_ARENA_BOSS_INFO(-1),
    BOSS_ARENA_USER_HP_CHANGED(-1),
    SPACE_MOON_RABBIT_FIELD_INFO(-1),
    SPACE_MOON_RABBIT_FIELD_STATE(-1),
    SPACE_MOON_RABBIT_USER_INFO_DC(-1),
    SPACE_MOON_RABBIT_USER_EFFECT(-1),
    SPACE_MOON_RABBIT_ATTACK_INFO(-1),
    SPACE_MOON_RABBIT_DAMAGE_INFO(-1),
    SPACE_MOON_RABBIT_PHASE_INFO(-1),
    FIELD_FADE_OBJECT_INFO(-1),

    RUNE_STONE_CLEAR_AND_ALL_REGISTER(1447),
    RUNE_STONE_DISAPPEAR(1448),
    RUNE_STONE_APPEAR(1449),
    STAR_PLANET_SCREEN_WORLD_EVENT(1451),
    FIELD_STATE_CREATE(1452),
    FIELD_STATE_REMOVE(1453),
    FIELD_CHASER_MOVE(1454),
    TWELFTH_THREASURE_UPDATE_GAME_INFO(-1),
    TWELFTH_THREASURE_FIELD_STATE_CHANGE(-1),
    POLO_FRITO_BOUNTY_HUNTING_STAGE(-1),
    POLO_FRITO_TOWN_DEFENSE_WAVE(-1),
    POLO_FRITO_TOWN_DEFENSE_LIFE(-1),
    POLO_FRITO_COURTSHIP_DANCE_STATE(-1),
    POLO_FRITO_COURTSHIP_DANCE_COMMAND(-1),
    UNK1421(-1),
    UNK1422(-1),
    UNK1423(-1),
    UNK1424(-1),
    UNK1425(-1),
    UNK1426(-1),
    UNK1427(-1),
    FIELD_RANDOM_STIGMA_INCINERATE(-1),
    FIELD_STIGMA_OBJECT_DEC(-1),
    DEMIAN_FLYING_SWORD_CREATE(-1),
    DEMIAN_FLYING_SWORD_MAKE_ENTER_REQUEST(-1),
    DEMIAN_FLYING_SWORD_MAKE_ENTER_INFO(-1),
    DEMIAN_FLYING_SWORD_NODE(-1),
    DEMIAN_FLYING_SWORD_TARGET(-1),
    DEMIAN_CORRUPTION_CHANGE(-1),
    UNK1436(-1),
    UNK1437(-1),
    UNK1438(-1),
    LUCID_BUTTERFLY_INIT(-1),
    LUCID_BUTTERFLY_ACTION(-1),
    UNK1441(-1),
    LUCID_DRAGON_INIT(-1),
    LUCID_DO_SKILL(-1),
    LUCID_STAINED_GLASS_ON_OFF(-1),
    LUCID_STAINED_GLASS_BREAK(-1),
    LUCID_STATUE_STATE_CHANGE(-1),
    LUCID_SET_FLYING_MODE(-1),
    LUCID_WELCOME_BARRAGE(-1),
    UNK1449(-1),
    UNK1450(-1),
    UNK1451(-1),
    UNK1452(-1),
    UNK1453(-1),
    UNK1454(-1),
    UNK1455(-1),
    UNK1456(-1),
    UNK1457(-1),
    UNK1458(-1),
    UNK1459(-1),
    UNK1460(-1),
    UNK1461(-1),
    UNK1462(-1),
    UNK1463(-1),
    UNK1464(-1),
    UNK1465(-1),
    UNK1466(-1),
    UNK1467(-1),
    UNK1468(-1),
    UNK1469(-1),
    UNK1470(-1),
    UNK1471(-1),
    UNK1472(-1),
    UNK1473(-1),
    UNK1474(-1),
    UNK1475(-1),
    UNK1476(-1),
    UNK1477(-1),
    UNK1478(-1),
    UNK1479(-1),
    UNK1480(-1),
    UNK1481(-1),
    UNK1482(-1),
    UNK1483(-1),
    UNK1484(-1),
    UNK1485(-1),
    UNK1486(-1),
    UNK1487(-1),
    UNK1488(-1),
    UNK1489(-1),
    UNK1490(-1),
    UNK1491(-1),
    UNK1492(-1),
    UNK1493(-1),
    UNK1494(-1),
    UNK1495(-1),
    UNK1496(-1),
    UNK1497(-1),
    UNK1498(-1),
    UNK1499(-1),
    H_RSP_1505(-1),
    H_RSP_1506(-1),
    H_RSP_1507(-1),
    H_RSP_1508(-1),
    H_RSP_1509(-1),
    UNK1520(-1),
    UNK1521(-1),
    UNK1522(-1),
    UNK1523(-1),
    UNK1524(-1),
    UNK1525(-1),
    UNK1526(-1),
    UNK1527(-1),
    UNK1528(-1),
    UNK1529(-1),
    UNK1530(-1),
    UNK1531(-1),
    BINGO_ENTER_GAME(-1),
    BINGO_HOST_NUMBER(-1),
    BINGO_HOST_NUMBER_READY(-1),
    BINGO_ADD_RANK(-1),
    BINGO_REMOVE_RANK(-1),
    BINGO_FINISH_RANK(-1),
    BINGO_CHECK_NUMBER_ACK(-1),
    BINGO_GAME_STATE(-1),
    TYPING_GAME_WAVE_INFO(-1),
    TYPING_GAME_ENTER(-1),
    TYPING_GAME_MOVE_TO_PORTAL(-1),
    TYPING_GAME_START(-1),
    TYPING_GAME_RESET_WORD(-1),
    TYPING_GAME_SCORE(-1),
    TYPING_GAME_RESULT(-1),
    TYPING_GAME_EFFECT(-1),
    TYPING_GAME_STATE(-1),
    TYPING_GAME_POINT_EFFECT(-1),
    TYPING_GAME_USER_SKILL_ATTACK(-1),
    TYPING_GAME_SUMMON(-1),
    H_OX_QUIZ_STATE(-1),
    H_OX_QUIZ_ENTER(-1),
    H_OX_QUIZ_QUESTIONS(-1),
    H_OX_QUIZ_EXPLAN(-1),
    H_OX_QUIZ_COUNT_EFFECT(-1),
    H_OX_QUIZ_MOVE_TO_PORTAL(-1),
    H_OX_QUIZ_RESULT(-1),
    UNK1559(-1),
    UNK1560(-1),
    UNK1561(-1),
    UNK1562(-1),
    UNK1563(-1),
    UNK1564(-1),
    UNK1565(-1),
    UNK1566(-1),
    UNK1567(-1),
    UNK1568(-1),
    UNK1569(-1),
    HORNTAIL_TIMER(-1),
    ZAKUM_TIMER(-1),
    UNK1572(-1),
    UNK1573(-1),
    UNK1574(-1),
    UNK1575(-1),
    UNK1576(-1),
    UNK1577(-1),
    UNK1578(-1),
    UNK1579(-1),
    UNK1580(-1),
    UNK1581(-1),
    UNK1582(-1),
    UNK1583(-1),
    UNK1584(-1),
    UNK1585(-1),
    SP_RPS_GAME_INIT(-1),
    SP_RPS_GAME_STATE(-1),
    SP_RPS_GAME_READY(-1),
    SP_RPS_GAME_START(-1),
    SP_RPS_GAME_SCORE(-1),
    SP_RPS_GAME_LEAVE_ACK(-1),
    SP_RPS_GAME_RESULT(-1),
    SSFS_GAME_INIT(-1),
    SSFS_READY(-1),
    SSFS_START(-1),
    SSFS_CLEAR(-1),
    SSFS_FAIL(-1),
    SSFS_USER_INFO(-1),
    SSFS_LETHAL_ATTACK(-1),
    UNK1608(-1),
    UNK1609(-1),
    UNK1610(-1),
    STAR_PLANET_HRPS_GAME(-1),
    STAR_PLANET_HRPS_GAME_STATE(-1),
    STAR_PLANET_HRPS_RESULT(-1),
    STAR_PLANET_HRPS_ROUND_RESULT(-1),
    STAR_PLANET_HRPS_SELECT_EFFECT(-1),
    STAR_PLANET_HRPS_ENTER_INTRUSION_USER(-1),
    REGISTER_BATTLE_USER(-1),
    UNREGISTER_BATTLE_USER(-1),
    BATTLE_USER_INFO(-1),
    VALID_BATTLE_USER(-1),
    JOB_SELECT_RESULT(-1),
    CHAMP_SELECT_TIMER(-1),
    BATTLE_USER_RESPAWN_UI(-1),
    BATTLE_PVP_POINT_EFFECT(-1),
    SET_BATTLE_ATTACK(-1),
    SET_BATTLE_ATTACK_EXPIRE(-1),
    SET_BATTLE_ATTACK_POSITION(-1),
    NEXT_BATTLE_ATTACK(-1),
    REPEAT_BATTLE_ATTACK(-1),
    SET_TEMPORARY_SKILL_SET(-1),
    USED_TEMPORARY_SKILL(-1),
    VALIDATE_TEMPORARY_SKILL(-1),
    VALIDATE_TEMPORARY_SKILL_SET(-1),
    RESET_COOLTIME_SKILL_SET(-1),

    // CScriptMan::OnPacket
    SCRIPT_MESSAGE(1723), //v205

    // CShopDlg::OnPacket
    SHOP_OPEN(1724),
    SHOP_RESULT(1725),


    GACH_OPEN(1506),
    GACH_RESULT(1507),

    ADMIN_SHOP_RESULT(-1),
    ADMIN_SHOP_COMMODITY(-1),
    QUEST_LOADING_PACKET(-1),
    UNK1689(-1),
    UNK1690(-1),
    UNK1691(-1),
    UNK1692(-1),
    UNK1693(-1),
    UNK1694(-1),
    SOUL_DUNGEON_SOUL_PIECE_CHANGE(-1),
    SOUL_DUNGEON_SOUL_ITEM_USE_VOTE_REQUEST(-1),
    SOUL_DUNGEON_SOUL_ITEM_USE_RESULT(-1),
    SOUL_DUNGEON_SOUL_ITEM_MAP_INFO(-1),
    SOUL_DUNGEON_SOUL_ITEM_MAP_INFO_CLOSE(-1),
    SOUL_DUNGEON_SOUL_ITEM_DATA_CHANGE(-1),
    SOUL_DUNGEON_SOUL_ITEM_VOTE_RESULT(-1),
    SOUL_DUNGEON_EFFECT(-1),
    SOUL_DUNGEON_MINI_MAP_INFO(-1),
    UNK1704(-1),
    UNK1705(-1),
    COORDINATION_RUNWAY_AVATAR(-1),
    UNK1707(-1),

    TRUNK_DLG(1750),
    STORE_BANK_GET_ALL_RESULT(-1),
    STORE_BANK_RESULT(-1),
    RPS_GAME_DLG(-1),
    GO_STOP_RPS_GAME_DLG(-1),
    STAR_PLANET_GO_STOP_RPS_DLG(-1),
    UI_MESSENGER(-1),
    MINI_ROOM_BASE_DLG(1757),
    MINI_ROOM_BASE_DLG_2(-1),
    SET_CASH_SHOP_INITIAL_ITEM(-1),
    TRY_MIGRATE_CASH_SHOP(-1),
    TRY_MIGRATE_CASH_SHOP_2(-1),
    TOURNAMENT(-1),
    TOURNAMENT_MATCH_TABLE(-1),
    TOURNAMENT_SET_PRICE(-1),
    TOURNAMENT_NOTICE_UEW(-1),
    TOURNAMENT_AVATAR_INFO(-1),
    UNK1725(-1),
    UNK1726(-1),
    UNK1727(-1),
    GHOST_PARK_RUNE_USE_ACK(-1),
    GHOST_PARK_RUNE_APPEAR(-1),
    GHOST_PARK_RUNE_DISAPPEAR(-1),
    GHOST_PARK_KILLED_MOB_BONUS_EXP_RATE_INFO(-1),
    GHOST_PARK_CURSE_LEVEL_EXP_RATE(-1),
    GHOST_PARK_HOMING_BULLET_CREATE(-1),
    UNK1734(-1),
    UNK1735(-1),
    UNK1736(-1),
    UNK1737(-1),
    UNK1738(-1),
    UNK1739(-1),
    UNK1740(-1),
    UNK1741(-1),
    UNK1742(-1),
    UNK1743(-1),
    UNK1744(-1),
    UNK1745(-1),
    UNK1746(-1),
    UNK1747(-1),
    UNK1748(-1),
    UNK1749(-1),
    UNK1750(-1),
    UNK1751(-1),
    UNK1752(-1),
    UNK1753(-1),
    UNK1754(-1),
    UNK1755(-1),
    UNK1756(-1),
    UNK1757(-1),
    UNK1758(-1),
    PARCEL_DLG(-1),

    // CCashShop::OnPacket
    CASH_SHOP(1810),
    CASH_SHOP_QUERY_CASH_RESULT(1811),
    CASH_SHOP_CASH_ITEM_RESULT(1812),
    CASH_SHOP_PURCHASE_EXP_CHANGED(1813),
    CASH_SHOP_CHAR_STAT_CHANGED(1815),
    UNK1766(1817),
    CASH_SHOP_MVP_ITEM_GIVE_RESULT(1819),
    CASH_SHOP_CHARGE_MILEAGE_NOTICE(1820),
    CASH_SHOP_REWARD_POINTS_RESULT(-1),
    UNK1771(-1),
    UNK1772(-1),
    UNK1773(-1),
    CASH_SHOP_CHECK_DUPLICATED_ID_RESULT(-1),
    CASH_SHOP_CHECK_NAME_POSSIBLE_RESULT(-1),
    surpriseBox(1830),
    CASH_SHOP_CHECK_TRASNFER_WORLD_POSSIBLE_RESULT(-1),
    CASH_SHOP_GACHAPON_STAMP_RESULT(-1),
    CASH_SHOP_NOTICE_FREE_CASH_ITEM(-1),
    CASH_SHOP_IDK10(-1),
    CASH_SHOP_IDK11(-1),
    UNK1782(-1),
    CASH_SHOP_INFO(1837),
    CASH_SHOP_ACTION(1838),
    UNK1785(-1),
    UNK1786(-1),
    UNK1787(-1),
    UNK1788(-1),
    UNK1789(-1),
    UNK1790(-1),
    UNK1791(-1),

    UNITY_PORTAL(1868),


    FUNC_KEY_MAPPED_MAN_INIT(1952),
    PET_CONSUME_ITEM_INIT(1953),
    PET_CONSUME_MP_ITEM(1954),
    PET_CONSUME_CURE_ITEM(1955),

    GOLD_HAMMER_ITEM_UPGRADE_RESULT(1973),

    FIELD_ATTACK_CREATE(1989),
    FIELD_ATTACK_REMOVE_BY_KEY(1990),
    FIELD_ATTACK_REMOVE_LIST(1991),
    FIELD_ATTACK_REMOVE_ALL(1992),
    FIELD_ATTACK_SET_ATTACK(1995),
    DOT_DAMAGE_INFO(2002),
    SERVER_ON_CALC_REQUEST_RESULT(2005),
    SOCKET_CREATE_RESULT(2011),
    NO(2044)
    ;


    private static List<OutHeader> spam = Arrays.asList(
            ALIVE_REQ,
            PRIVATE_SERVER_PACKET,
            MOB_CONTROL_ACK,
            CHAT_MSG,
            MOB_HP_INDICATOR,
            STAT_CHANGED,
            MOB_CHANGE_CONTROLLER,
            MOB_MOVE,
            REMOTE_MOVE,
            REMOTE_EMOTION,
            EXCL_REQUEST,
            NPC_MOVE,
            DROP_LEAVE_FIELD,
            TEMPORARY_STAT_RESET,
            PET_MOVE,
            NPC_ENTER_FIELD,
            NPC_CHANGE_CONTROLLER,
            MOB_ENTER_FIELD,
            RESULT_INSTANCE_TABLE,
            CREATE_OBTACLE,
            DROP_ENTER_FIELD,
            MOB_LEAVE_FIELD,
            MESSAGE,
            TEMPORARY_STAT_SET
    );

    private short value;

    OutHeader(int value) {
        this.value = (short) value;
    }

    public short getValue() {
        return value;
    }

    public static OutHeader getOutHeaderByOp(int op) {
        for (OutHeader outHeader : OutHeader.values()) {
            if (outHeader.getValue() == op) {
                return outHeader;
            }
        }
        return null;
    }

    public static boolean isSpamHeader(OutHeader outHeader) {
        return spam.contains(outHeader);
    }

}